Imports System.Data.Common
Imports System.Data.SQLite
Imports System.IO
Module Util
    Public dataBase As String = ""
    Public Sub cargarNombresYNumsLlave(ByVal tabla As String, _
                                          ByRef nombresArgs() As String, _
                                          ByVal numArgsLlave() As Integer _
                                          )
        'Esta rutina carga para cada tablas los nombres de los campos en el arreglo nombresArgs()
        'Los numeros de los campos que son llaves los carga en el arreglo numArgsLlave()
        'De esta manera se concentra aqui la descripcion de las tablas
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.cargarNombresYNumsLlave: La tabla no puede estar vacia")
        End If
        If tabla.Trim.Equals("") Then
            MsgBox("Util.cargarNombresYNumsLlave: La tabla no puede estar vacia")
        End If
        '2.- cargar los nommbres y llaves de cada tabla
        'Esta parte se debe agregar para cada una de las tablas de la BD
        Dim tiposCampos(nombresArgs.Length) As String
        Dim tiposCaptura(nombresArgs.Length) As String
        cargarDescripcionTabla(tabla, nombresArgs, numArgsLlave, tiposCampos, tiposCaptura)
    End Sub
    Public Sub cargarDescripcionTabla(ByVal tabla As String, _
                                         ByRef nombresArgs() As String, _
                                         ByRef numArgsLlave() As Integer, _
                                         ByRef tiposCampos() As String, _
                                         ByRef tiposCaptura() As String _
                                         )
        tabla = tabla.ToLower()
        Dim ruta As String = Application.StartupPath() + "\SalidaEsquema\"
        Dim tablasExistencia(nombresArgs.Length) As String
        cargarDatosDeLaTabla(tabla, ruta, nombresArgs, numArgsLlave, tiposCampos, tiposCaptura, tablasExistencia)

    End Sub
    Public Sub cargarDescripcionTabla(ByVal tabla As String, _
                                         ByRef nombresArgs() As String, _
                                         ByRef numArgsLlave() As Integer, _
                                         ByRef tiposCampos() As String, _
                                         ByRef tiposCaptura() As String, _
                                         ByRef tablasExistencia() As String _
                                         )
        tabla = tabla.ToLower()
        Dim ruta As String = Application.StartupPath() + "\SalidaEsquema\"
        cargarDatosDeLaTabla(tabla, ruta, nombresArgs, numArgsLlave, tiposCampos, tiposCaptura, tablasExistencia)
    End Sub
    Public Function numeroCampos(ByVal tabla As String, ByRef nCampos As Integer, ByRef nLlaves As Integer) As Integer
        'Esta rutina pone en nCampos el numero ded campos que tiene una tabla
        'Pone en nLlaves cuantos campos forman la llave de la tabla
        'De esta manera se concentra aqui la descripcion de las tablas
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.numeroCampos: La tabla no puede estar vacia")
        End If
        If tabla.Trim.Equals("") Then
            MsgBox("Util.numeroCampos: La tabla no puede estar vacia")
        End If
        '2.- cargar cuantos campos tiene la tabla
        'Esta parte se debe agregar para cada una de las tablas de la BD
        If tabla.Equals("mascotas") Then
            nCampos = 5
            nLlaves = 1
            Return nCampos
        End If
        tabla = tabla.ToLower()
        Dim i, nTab As Integer
        Dim ruta As String = Application.StartupPath() + "\SalidaEsquema\"
        Dim tablaTemp As String
        Dim entrada As String = ruta + "Tablas_" + dataBase + ".txt"
        'Variable temporal para leer 
        Dim regLeido As String
        Dim archEntrada As StreamReader = abreArchivoEntrada(entrada)
        regLeido = archEntrada.ReadLine()
        nTab = 0
        While Not archEntrada.EndOfStream
            nTab = nTab + 1
            i = nTab
            tablaTemp = regLeido.Trim().ToLower
            Try
                regLeido = archEntrada.ReadLine()
                nCampos = Integer.Parse(regLeido.Trim())
            Catch ex As Exception
                MsgBox("cargarDatosDeLaTabla: Datos Invalidos en la descripcion de la tabla para el numero de campos(" & _
                tabla & ") archivo de entrada (" & entrada & ")" _
                & vbCrLf & "dato leido (" & regLeido.Trim() & ") mensaje: " & ex.Message)
                nCampos = 0
            End Try
            Try
                regLeido = archEntrada.ReadLine()
                nLlaves = Integer.Parse(regLeido.Trim())
            Catch ex As Exception
                MsgBox("cargarDatosDeLaTabla: Datos Invalidos en la descripcion de la tabla para el numero de llaves(" & _
                tabla & ") archivo de entrada (" & entrada & ")" _
                & vbCrLf & "dato leido (" & regLeido.Trim() & ") mensaje: " & ex.Message)
                nLlaves = 0
            End Try
            If tabla.Equals(tablaTemp) Then
                archEntrada.Close()
                Return nCampos
            End If
            regLeido = archEntrada.ReadLine()
        End While
        archEntrada.Close()
        MsgBox("Util.numeroCampos: La tabla (" + tabla + " ) no esta dada de alta en esta rutina")
        Return 0
    End Function
   
    Public Function ConectarBD() As SQLiteConnection
        '1.-Revisar la variable con la Bd 
        Dim con As SQLiteConnection
        '2.-Crear el String de Conexion, ojo con el nombre del server
        Dim xstring As String
        xstring = "Data Source=" & dataBase & "; Pooling=False"
        '3.-Crear el objeto de la conexion
        con = New SQLiteConnection(xstring)
        '4.-Abrir la conexin si la Base de Datos no existe ser automticamente creada
        con.Open()
        con.Close()
        Return con
    End Function

    Public Function EjecutarSelect(ByRef conexion As SQLiteConnection, _
                                   ByVal tabla As String, _
                                   ByVal campos As String, _
                                   ByVal condicion As String _
                                    ) As DbDataReader
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.EjecutarSelect: La tabla no puede estar vacia")
        End If
        If conexion Is Nothing Then
            MsgBox("Util.EjecutarSelect: La conexion no es valida")
        End If
        If tabla.Equals("") Then
            MsgBox("Util.EjecutarSelect: La tabla no puede estar vacia")
        End If
        '2.-Obtener los datos
        Dim reader As DbDataReader
        Try
            conexion.Open()
        Catch ex As Exception

        End Try
        '3.-Crear un Comando para la conexin recibida
        Dim ComandoSelect As String = ""
        ComandoSelect = "SELECT " & campos & " FROM " & tabla
        'MsgBox("Util.EjecutarSelect: Trata de ejecutar comando Select  (" + ComandoSelect + ")")
        Dim ObjComando As DbCommand = conexion.CreateCommand()
        If Not condicion.Equals("") Then
            ComandoSelect = ComandoSelect + " " + condicion
        End If
        'MsgBox("Util.EjecutarSelect:  Comando Select Ejecutado (" + ComandoSelect + ")")
        Try
            ObjComando.CommandText = ComandoSelect
        Catch ex As Exception
            MsgBox("Util.EjecutarSelect:  No se pudo asignar el comando (" + ComandoSelect + ") mensaje recibido:" & ex.Message)
            Stop
        End Try
        ObjComando.CommandText = ComandoSelect
        '3.-Especificar el tipo de comando
        Try
            reader = ObjComando.ExecuteReader()
        Catch ex As Exception
            MsgBox("Util.EjecutarSelect:  No se pudo ejecutar el comando (" + ComandoSelect + ") mensaje recibido:" & ex.Message)
            Return Nothing
        End Try
        Return reader
    End Function
    Public Function EjecutarInsert(ByRef conexion As SQLiteConnection, _
                                          ByVal tabla As String, _
                                          ByVal nombresArgs() As String, _
                                          ByVal args() As String _
                                          ) As Integer
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.EjecutarInsert: La tabla no puede estar vacia")
        End If
        If conexion Is Nothing Then
            MsgBox("Util.EjecutarInsert: La conexion no es valida")
        End If
        If tabla.Equals("") Then
            MsgBox("Util.EjecutarInsert: La tabla no puede estar vacia")
        End If
        If nombresArgs.Length - 1 = 0 Then
            MsgBox("Util.EjecutarInsert: No hay nombres de campos")
        End If
        If args.Length - 1 = 0 Then
            MsgBox("Util.EjecutarInsert: No hay valores de campos")
        End If
        '2.- Formar el comando Insert
        Dim comandoInsert As String
        Dim renglonesAfectados, i As Integer
        comandoInsert = "INSERT INTO " + tabla + " "
        comandoInsert = comandoInsert + "(     "
        For i = 1 To (args.Length - 2)
            comandoInsert = comandoInsert + nombresArgs(i) + ", "
        Next i
        comandoInsert = comandoInsert + nombresArgs(args.Length - 1) + ") VALUES (  "
        For i = 1 To (args.Length - 2)
            comandoInsert = comandoInsert + "'" & args(i) & "', "
        Next i
        comandoInsert = comandoInsert + " '" & args(args.Length - 1) & "');"
        'MsgBox("Util.EjecutarInsert: Comando Insert a ejecutar:(" + comandoInsert + ")")
        '3.- Abrir la conexion
        Try
            conexion.Dispose()
            conexion = ConectarBD()
        Catch ex As Exception

        End Try

        Try
            conexion.Open()
        Catch ex As Exception
            Try
                conexion.Dispose()
                conexion = ConectarBD()
                conexion.Open()
            Catch ex2 As Exception
                MsgBox("Util.EjecutarInsert: Aborta No puedo hacer la conexion despues del dispose:" & ex2.Message)
                Stop
            End Try
            'MsgBox("Util.EjecutarInsert: No se pudo hacer la conexion mensaje recibido:" & ex.Message)
            'Return Nothing
        End Try
        '4.- Ejecutar el comando
        Dim ObjComando As DbCommand = conexion.CreateCommand()
        ObjComando.CommandText = comandoInsert
        Try
            renglonesAfectados = ObjComando.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox("Util.EjecutarInsert:  No se pudo ejecutar el comando (" + comandoInsert + ") mensaje recibido:" & ex.Message)
            Return Nothing
        End Try
        '5.-Cerrar la conexion y terminar
        conexion.Close()
        Return renglonesAfectados
    End Function

    Public Function EjecutarUpdate(ByRef conexion As SQLiteConnection, _
                                          ByVal tabla As String, _
                                          ByVal nombresArgs() As String, _
                                          ByVal args() As String, _
                                          ByVal numArgsLlave() As Integer _
                                          ) As Integer
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.EjecutarUpdate: La tabla no puede estar vacia")
        End If
        If conexion Is Nothing Then
            MsgBox("Util.EjecutarUpdate: La conexion no es valida")
        End If
        If tabla.Equals("") Then
            MsgBox("Util.EjecutarUpdate: La tabla no puede estar vacia")
        End If
        If nombresArgs.Length - 1 = 0 Then
            MsgBox("Util.EjecutarUpdate: No hay nombres de campos")
        End If
        If args.Length - 1 = 0 Then
            MsgBox("Util.EjecutarUpdate: No hay valores de campos")
        End If
        If numArgsLlave.Length - 1 = 0 Then
            MsgBox("Util.EjecutarUpdate: No hay numeros de los campos llave")
        End If
        '2.- Formar el comando Update
        Dim comandoUpdate As String
        Dim renglonesAfectados, i As Integer
        comandoUpdate = "UPDATE " + tabla + " "

        comandoUpdate = comandoUpdate + "   SET   "
        For i = 1 To (args.Length - 2)
            comandoUpdate = comandoUpdate + nombresArgs(i) + " = '" & args(i) & "', "
        Next i
        comandoUpdate = comandoUpdate + nombresArgs(args.Length - 1) + " = '" & args(args.Length - 1) & "'  "
        comandoUpdate = comandoUpdate + " WHERE " + nombresArgs(numArgsLlave(1)) + " = '" & args(numArgsLlave(1)) & "'"
        If numArgsLlave.Length - 2 > 0 Then
            For i = 2 To numArgsLlave.Length - 1
                comandoUpdate = comandoUpdate + " AND " + nombresArgs(numArgsLlave(i)) + " = '" & args(numArgsLlave(i)) & "'  "
            Next i
        End If
        'MsgBox("Util.EjecutarUpdate: Comando Update a ejecutar:(" + comandoUpdate + ")")
        '3.- Abrir la conexion
        Try
            conexion.Open()
        Catch ex As Exception
            Try
                conexion.Dispose()
                conexion = ConectarBD()
                conexion.Open()
            Catch ex2 As Exception
                MsgBox("Util.EjecutarUpdate: Aborta No puedo hacer la conexion despues del dispose:" & ex2.Message)
                Stop
            End Try
            'MsgBox("Util.EjecutarUpdate: No se pudo hacer la conexion mensaje recibido:" & ex.Message)
            'Return Nothing
        End Try
        '4.- Ejecutar el comando
        Dim ObjComando As DbCommand = conexion.CreateCommand()
        ObjComando.CommandText = comandoUpdate
        Try
            renglonesAfectados = ObjComando.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox("Util.EjecutarUpdate:  No se pudo ejecutar el comando (" + comandoUpdate + ") mensaje recibido:" & ex.Message)
            Return Nothing
        End Try
        '5.-Cerrar la conexion y terminar
        conexion.Close()
        Return renglonesAfectados
    End Function
    Public Function EjecutarDelete(ByRef conexion As SQLiteConnection, _
                                          ByVal tabla As String, _
                                          ByVal nombresArgs() As String, _
                                          ByVal args() As String, _
                                          ByVal numArgsLlave() As Integer _
                                          ) As Integer
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.ejecutarDelete: La tabla no puede estar vacia")
        End If
        If conexion Is Nothing Then
            MsgBox("Util.ejecutarDelete: La conexion no es valida")
        End If
        If tabla.Equals("") Then
            MsgBox("Util.ejecutarDelete: La tabla no puede estar vacia")
        End If
        If nombresArgs.Length - 1 = 0 Then
            MsgBox("Util.ejecutarDelete: No hay nombres de campos")
        End If
        If args.Length - 1 = 0 Then
            MsgBox("Util.ejecutarDelete: No hay valores de campos")
        End If
        If numArgsLlave.Length - 1 = 0 Then
            MsgBox("Util.ejecutarDelete: No hay numeros de los campos llave")
        End If
        '2.- Formar el comando Delete
        Dim comandoDelete As String
        Dim renglonesAfectados, i As Integer
        comandoDelete = "DELETE FROM " + tabla + " "
        comandoDelete = comandoDelete + " WHERE " + nombresArgs(numArgsLlave(1)) + " = '" & args(numArgsLlave(1)) & "'"
        If numArgsLlave.Length - 1 > 0 Then
            For i = 2 To numArgsLlave.Length - 1
                comandoDelete = comandoDelete + " AND " + nombresArgs(numArgsLlave(i)) + " = '" & args(numArgsLlave(i)) & "'  "
            Next i
        End If
        'MsgBox("Util.ejecutarDelete: Comando Update a ejecutar:(" + comandoDelete + ")")
        '3.- Abrir la conexion
        Try
            conexion.Open()
        Catch ex As Exception
            Try
                conexion.Dispose()
                conexion = ConectarBD()
                conexion.Open()
            Catch ex2 As Exception
                MsgBox("Util.EjecutarDelete: Aborta No puedo hacer la conexion despues del dispose:" & ex2.Message)
                Stop
            End Try

            'MsgBox("Util.ejecutarDelete: No se pudo hacer la conexion mensaje recibido:" & ex.Message)
            'Return Nothing
        End Try
        '4.- Ejecutar el comando
        Dim ObjComando As DbCommand = conexion.CreateCommand()
        ObjComando.CommandText = comandoDelete
        Try
            renglonesAfectados = ObjComando.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox("Util.ejecutarDelete:  No se pudo ejecutar el comando (" + comandoDelete + ") mensaje recibido:" & ex.Message)
            Return Nothing
        End Try
        '5.-Cerrar la conexion y terminar
        conexion.Close()
        Return renglonesAfectados
    End Function
    Public Function borraTodosRegsTablaTrabajo(ByRef w_cnn As SQLiteConnection, ByVal w_Tabla As String) As Boolean
        'borra todos los registros de la tabla w_Tabla
        Dim w_Ncampos, renglonesAfectados As Integer
        Dim w_Nkeys As Integer
        w_Ncampos = Util.numeroCampos(w_Tabla, w_Ncampos, w_Nkeys)
        Dim nombres(w_Ncampos), valores(w_Ncampos) As String
        Dim Keys(w_Nkeys) As Integer
        cargarNombresYNumsLlave(w_Tabla, nombres, Keys)
        '
        Dim comandoDelete As String = "DELETE FROM " + w_Tabla + " "
        MsgBox("Util.ejecutarDelete: Comando Update a ejecutar:(" + comandoDelete + ")")
        Try
            w_cnn.Open()
            'MsgBox("Util.borraTodosRegsTablaTrabajo: Abrio la conexion")
        Catch ex As Exception
        End Try
        'MsgBox("Util.borraTodosRegsTablaTrabajo: Estado de la conexion" & w_cnn.State.ToString)
        'Ejecutar el comando
        Dim ObjComando As DbCommand = w_cnn.CreateCommand()
        ObjComando.CommandText = comandoDelete
        Try
            renglonesAfectados = ObjComando.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox("Util.borraTodosRegsTablaTrabajo:  ABORTA No se pudo ejecutar el comando (" + comandoDelete + ") mensaje recibido:" & ex.Message)
            Return False
        End Try
        w_cnn.Close()
        'MsgBox("Tabla de trabajo2( " + w_Tabla + ")ha sido limpiada se borraron (" + renglonesAfectados.ToString + ")")
    End Function
    Public Sub insertaRegTabla(ByRef w_cnn As SQLiteConnection, ByVal w_Tabla As String, ByVal w_Registro As String())
        'inserta el registro en el arreglo w_Registro en la tabla w_Tabla
        'Crear un Comando para la conexin recien creada
        '
        Dim w_Ncampos As Integer = w_Registro.Length
        Dim w_Nkeys As Integer
        w_Ncampos = Util.numeroCampos(w_Tabla, w_Ncampos, w_Nkeys)
        Dim nombres(w_Ncampos), valores(w_Ncampos) As String
        Dim Keys(w_Nkeys) As Integer
        cargarNombresYNumsLlave(w_Tabla, nombres, Keys)
        If Not Util.EjecutarInsert(w_cnn, w_Tabla, nombres, w_Registro) = 1 Then
            MsgBox("Error al dar de alta el registro en la Tabla de trabajo (" + w_Tabla + ")")
            w_cnn.Close()
            Return
        End If
    End Sub
    Public Function cargaCampo(ByVal nombreCampo As String, _
                               ByVal valorCampo As String, _
                               ByVal nombresArgs() As String, _
                               ByRef args() As String) As Boolean
        '1.-validar los parametros recibidos
        If nombreCampo Is Nothing Then
            MsgBox("Util.cargaCampo: El nombre de campo no puede estar vacio")
        End If
        If nombreCampo.Equals("") Then
            MsgBox("Util.cargaCampo: El nombre de campo no puede estar vacio")
        End If
        '2.- cargar el valor del campo en la posicion que le corresponde
        Dim i As Integer
        For i = 1 To args.Length - 1
            If nombresArgs(i).Equals(nombreCampo) Then
                args(i) = valorCampo
                Return True
            End If
        Next i
        Return False
    End Function
    Public Function recuperaValor(ByVal nombreCampo As String, _
                               ByVal nombresArgs() As String, _
                               ByRef args() As String) As String
        '1.-validar los parametros recibidos
        If nombreCampo Is Nothing Then
            MsgBox("Util.cargaCampo: El nombre de campo no puede estar vacio")
        End If
        If nombreCampo.Equals("") Then
            MsgBox("Util.cargaCampo: El nombre de campo no puede estar vacio")
        End If
        '2.- Recupera el valor del campo de la posicion que le corresponde
        Dim i As Integer
        For i = 1 To args.Length - 1
            If nombresArgs(i).Equals(nombreCampo) Then
                Return args(i)
            End If
        Next i
        MsgBox("No se encontro este campo (" & nombreCampo & ")")
        Return ""
    End Function
    Public Sub CargaArreglo(ByVal reader As DbDataReader, _
                                   ByRef args() As String)
        '1.-validar los parametros recibidos
        If reader Is Nothing Then
            MsgBox("Util.CargaArreglo: El reader no puede estar vacio")
        End If
        '2.-Obtener los datos
        Dim i As Integer
        Using reader
            While reader.Read()
                For i = 1 To args.Length - 1
                    args(i) = reader(i - 1)
                    'MsgBox("Util.CargaArreglo: cargo campo (" + args(i) + ")")
                Next i
            End While
        End Using
    End Sub
    Public Sub CargaArregloBidimensional(ByVal reader As DbDataReader, _
                                   ByRef args(,) As String, ByVal nCampos As Integer, ByRef nRenglones As Integer)
        '1.-validar los parametros recibidos
        If reader Is Nothing Then
            MsgBox("Util.CargaArregloBidimensional: El reader no puede estar vacio")
        End If
        '2.-Obtener los datos
        Dim j, i, k As Integer
        i = 0
        k = 0
        nRenglones = 0
        Using reader
            While reader.Read()
                'MsgBox("Al cargar i=( " + i.ToString + ")")
                i = i + 1
                For j = 1 To nCampos
                    Try
                        args(i, j) = reader(j - 1)
                    Catch ex As Exception
                        'MsgBox("Util.CargaArregloBidimensional: Detecto llaves repetidas en la BD i=(" + i.ToString + ") j=( " + j.ToString + ") arg leido del reader invalido")
                        nRenglones = nRenglones - 1
                        Exit For
                    End Try
                    'MsgBox("Truena con i=(" + i.ToString + ") j=( " + j.ToString + ") arg leido del reader (" + args(i, j) + ")")

                Next j
            End While
        End Using
        nRenglones = nRenglones + i
        'MsgBox("CargaArregloBidimensional Se cargaron ( " + nRenglones.ToString + ")")
    End Sub
    Public Sub cargaCombo(ByRef combo As ComboBox, _
                          ByVal tabla As String, _
                          ByVal limpiar As Boolean)
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.cargaCombo: La tabla no puede estar vacia")
        End If
        If tabla.Equals("") Then
            MsgBox("Util.cargaCombo: La tabla no puede estar vacia")
        End If
        If combo Is Nothing Then
            MsgBox("Util.cargaCombo: El combo tabla no puede estar vacio")
        End If
        Dim cnn As SQLiteConnection = ConectarBD()
        '2.- estructura de datos
        'Crear un Comando para la conexin recien creada
        Dim campos As String = "*"
        Dim condicion As String = ""
        Dim reader As DbDataReader
        reader = Util.EjecutarSelect(cnn, tabla, campos, condicion)
        If limpiar Then
            combo.Items.Clear()
        End If
        If reader Is Nothing Then
            MsgBox("Util.cargaCombo: El reader no ley registros")
            Return
        End If
        '3.-Obtener los datos
        Dim Elemento As String
        If reader.HasRows Then
            Do While reader.Read()
                Elemento = reader.GetValue(0)
                combo.Items.Add(Elemento)
                'escribeParent(Elemento)
            Loop
        End If
        cnn.Close()
    End Sub

    Public Sub cargaColCombo(ByRef ColCombo As DataGridViewComboBoxColumn, _
                          ByVal tabla As String, _
                          ByVal nombreCol As String, _
                          ByVal numCampo As Integer, _
                          ByVal limpiar As Boolean)
        '1.-validar los parametros recibidos
        If tabla Is Nothing Then
            MsgBox("Util.cargaColComboo: La tabla no puede estar vacia")
            Return
        End If
        If tabla.Equals("") Then
            MsgBox("Util.cargaColCombo: La tabla no puede estar vacia")
            Return
        End If
        If ColCombo Is Nothing Then
            MsgBox("Util.cargaColCombo: El combo tabla no puede estar vacio")
            Return
        End If
        If numCampo < 1 Then
            MsgBox("Util.cargaColCombo: El numero de campo no puede ser menor a 1")
            Return
        End If
        Dim cnn As SQLiteConnection = ConectarBD()
        '2.- estructura de datos
        'Crear un Comando para la conexin recien creada
        Dim campos As String = "*"
        Dim condicion As String = ""
        Dim reader As DbDataReader
        reader = Util.EjecutarSelect(cnn, tabla, campos, condicion)
        If limpiar Then
            ColCombo.Items.Clear()
        End If
        If reader Is Nothing Then
            MsgBox("Util.cargaColCombo: El reader no ley registros")
            Return
        End If
        '3.-Obtener los datos
        If reader.HasRows Then
            Do While reader.Read()
                ColCombo.Items.Add(reader.GetValue(numCampo - 1))
            Loop
        End If
        ColCombo.HeaderText = tabla
        ColCombo.DataPropertyName = nombreCol
        cnn.Close()
    End Sub

    Public Function validar(ByVal texto As String, ByVal entero As Integer) As Boolean
        Try
            entero = Integer.Parse(texto)
        Catch ex As Exception
            MsgBox("Error en el numero entero tecleado")
            Return False
        End Try
        Return True
    End Function

    Public Function validar(ByVal texto As String, ByVal flotante As Double)
        Try
            flotante = Double.Parse(texto)
        Catch ex As Exception
            MsgBox("Error en el numero con decimales tecleado")
            Return False
        End Try
        Return True
    End Function
    Public Function validar(ByVal texto As String, ByVal fecha As Date)
        Try
            fecha = Date.Parse(texto)
        Catch ex As Exception
            MsgBox("Error en la fecha")
            Return False
        End Try
        Return True
    End Function
    Public Function validar(ByVal texto As String, ByVal flotante As Single) As Boolean
        Try
            flotante = Single.Parse(texto)
        Catch ex As Exception
            MsgBox("Error en el numero con decimales tecleado")
            Return False
        End Try
        Return True
    End Function
    Public Function validar(ByVal textoAlfabetico As String, ByVal variable As String) As Boolean
        'MsgBox("Valida textoNumerico= " + textoNumerico)
        If textoAlfabetico = "" Then
            Return False
        End If
        If EsAlfabetico(textoAlfabetico) Then
            Return True
        Else
            Return False
        End If
    End Function
    Public Function EsAlfabetico(ByVal TestString As String) As Boolean
        Dim sTemp As String
        Dim iLen As Integer
        Dim iCtr As Integer
        Dim sChar As String
        EsAlfabetico = False
        'returns true if all characters in a string are alphabetical
        'returns false otherwise or for empty string
        sTemp = TestString
        iLen = Len(sTemp)
        If iLen > 0 Then
            For iCtr = 1 To iLen
                sChar = Mid(sTemp, iCtr, 1)
                If Not (sChar Like "[A-Za-z]" Or sChar = " ") Then
                    MsgBox("Error: Campo Alfabetico Invalido")
                    Exit Function
                End If
            Next
            EsAlfabetico = True
        End If
    End Function
    Public Function validarId(ByVal textoAlfabetico As String) As Boolean
        'MsgBox("Valida texto= " + textoAlfabetico)
        If textoAlfabetico = "" Then
            'MsgBox("Campo vacio texto= " + textoAlfabetico)
            Return False
        End If
        If EsAlfabeticoConNumeros(textoAlfabetico) Then
            'MsgBox("Todo OK Es alfabetico texto= " + textoAlfabetico)
            Return True
        Else
            'MsgBox("No es alfabetico texto= " + textoAlfabetico)
            Return False
        End If
    End Function
    Public Function EsAlfabeticoConNumeros(ByVal TestString As String) As Boolean
        Dim sTemp As String
        Dim iLen As Integer
        Dim iCtr As Integer
        Dim sChar As String
        EsAlfabeticoConNumeros = False
        'returns true if all characters in a string are alphabetical
        'returns false otherwise or for empty string
        sTemp = TestString
        iLen = Len(sTemp)
        If iLen > 0 Then
            For iCtr = 1 To iLen
                sChar = Mid(sTemp, iCtr, 1)
                If Not (sChar Like "[A-Za-z]" Or sChar Like "[0-9]" Or sChar = "_") Then
                    MsgBox("Error: Campo Id Invalido")
                    Exit Function
                End If
            Next
            EsAlfabeticoConNumeros = True
        End If
    End Function
    
    Public Sub GeneraYMuestraElDataSetDeUnArreglo(ByRef arreglo(,) As String, _
                                                  ByRef DataSetDelArchivo As Data.DataSet, _
                                                  ByRef DataGridView1 As DataGridView, _
                                                  ByVal nombreCols() As String, _
                                                  ByVal nRegs As Integer, _
                                                  ByVal nCols As Integer, _
                                                  ByVal tipoCols() As String)
        'Parametros de Entrada
        'arreglo.-Arreglo bidimensional con los datos a mostrar en el Data Set
        'nombreCols().-Arreglo para contener los nombres de las columnas
        'nCols.-Numero de columnas
        'tipoCols.-Arreglo para contener los tipos de las columnas 
        'Parametros de Salida
        'DataSetDelArchivo.-Nombre del objeto DataSet que se regresa con los datos
        'DataGridView1.-Nombre del objeto DataGridView para contener el dataSet


        '1.-Generar el objeto DataSet y ponerle nombre, un data set puede tener varias tablas
        'Dim DataSetDelArchivo As New DataSet("Archivo")
        '2.-Generar un objeto tabla y agregarlo al datasetDataSet
        Dim Tabla = DataSetDelArchivo.Tables.Add("Tabla")

        '3.-Generar el objeto columna y ponerle nombre para futura referencia, solo se le pone nombre si se va a requerir referirse a ella despus
        'Dim pkCol = Tabla.Columns.Add("Folio", Type.GetType("System.Int32"))
        '4.-Generar las columnas
        Dim tipo As String
        Dim i As Integer

        For i = 1 To nCols
            Select Case tipoCols(i)
                Case "String"
                    tipo = "System.String"
                Case "Single"
                    tipo = "System.Single"
                Case "Double"
                    tipo = "System.Double"
                Case "Boolean"
                    tipo = "System.Boolean"
                Case "Integer"
                    tipo = "System.Int32"
                Case Else
                    tipo = "System.String"
            End Select
            Tabla.Columns.Add(nombreCols(i), Type.GetType(tipo))
        Next i
        '5.-Carga el Data Set con datos del archivo
        CargaElDataSet(arreglo, Tabla, tipoCols, nRegs, nCols)
        '6.-Hacer la liga entre el Data Set y el panel, para esto se utiliza un DataGridView
        DataGridView1.DataSource = DataSetDelArchivo.Tables(0)
    End Sub


    Private Sub CargaElDataSet(ByVal arreglo(,) As String, ByVal Tabla As DataTable, ByVal tipoCols() As String, _
                               ByVal nRegs As Integer, ByVal nCols As Integer)
        If nCols > 15 Then
            MsgBox("CargaElDataSet: Esta rutina solo maneja hasta 15 columnas")
            Return
        End If
        Dim valoresString(nCols) As String
        Dim i, j As Integer
        For i = 1 To nRegs
            For j = 1 To nCols
                valoresString(j) = arreglo(i, j)
            Next j
            Select Case nCols
                Case 1
                    Tabla.Rows.Add(valoresString(1))
                Case 2
                    Tabla.Rows.Add(valoresString(1), valoresString(2))
                Case 3
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3))
                Case 4
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4))
                Case 5
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5))
                Case 6
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), valoresString(6))
                Case 7
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                                                    valoresString(6), valoresString(7))
                Case 8
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                                                    valoresString(6), valoresString(7), valoresString(8))
                Case 9
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                                                    valoresString(6), valoresString(7), valoresString(8), valoresString(9))
                Case 10
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10))
                Case 11
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10), valoresString(11))
                Case 12
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10), valoresString(11), _
                     valoresString(12))
                Case 13
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10), valoresString(11), _
                     valoresString(12), valoresString(13))
                Case 14
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10), valoresString(11), _
                     valoresString(12), valoresString(13), valoresString(14))
                Case 15
                    Tabla.Rows.Add(valoresString(1), valoresString(2), valoresString(3), valoresString(4), valoresString(5), _
                     valoresString(6), valoresString(7), valoresString(8), valoresString(9), valoresString(10), valoresString(11), _
                     valoresString(12), valoresString(13), valoresString(14), valoresString(15))
            End Select
        Next i
    End Sub
    Public Sub escribe(ByVal mensaje As String)
        Console.WriteLine("*********  " & mensaje)
    End Sub
    Public Sub escribeParent(ByVal mensaje As String)
        Console.WriteLine("*********  valor de la variable es (" & mensaje & ")")
    End Sub
    Public Sub escribeArreglo(ByVal arreglo() As String, ByVal n As Integer)
        Dim i As Integer
        For i = 1 To n
            Console.WriteLine("*********  valor del elemento(" & i.ToString & ")  contenido (" & arreglo(i) & ")")
        Next
    End Sub
    Public Sub escribeArregloLinea(ByVal arreglo() As String, ByVal n As Integer)
        Dim i As Integer
        For i = 1 To n
            Console.Write("(" & arreglo(i) & ")")
        Next
        Console.WriteLine(" ")
    End Sub
    Public Sub escribeArreglo(ByVal arreglo() As Integer, ByVal n As Integer)
        Dim i As Integer
        For i = 1 To n
            Console.WriteLine("*********  valor del elemento(" & i.ToString & ")  contenido (" & arreglo(i).ToString & ")")
        Next
    End Sub
    Public Sub escribeArreglo(ByVal arreglo() As Double, ByVal n As Integer)
        Dim i As Integer
        For i = 1 To n
            Console.WriteLine("*********  valor del elemento(" & i.ToString & ")  contenido (" & arreglo(i).ToString & ")")
        Next
    End Sub
    Public Sub DesglozaFecha(ByRef aaaa As String, ByRef mm As String, ByRef dd As String, ByVal fecha As String)
        dd = fecha.Substring(0, 2)
        mm = fecha.Substring(3, 2)
        aaaa = fecha.Substring(6, 4)
    End Sub
    Public Function ComponeFechaAaaaMmDd(ByVal fechaDdMmAaaa As String) As String
        Dim aaaa, mm, dd As String
        fechaDdMmAaaa = fechaDdMmAaaa.PadLeft(10, "0")
        dd = fechaDdMmAaaa.Substring(0, 2)
        mm = fechaDdMmAaaa.Substring(3, 2)
        aaaa = fechaDdMmAaaa.Substring(6, 4)
        Return aaaa + "/" + mm + "/" + dd
    End Function
    Public Function ComponeFechaHora(ByVal fechaDdMmAaaa As String, ByVal hora As String) As String
        Dim aaaa, mm, dd, hr, mins, segs As String
        dd = fechaDdMmAaaa.Substring(0, 2)
        mm = fechaDdMmAaaa.Substring(3, 2)
        aaaa = fechaDdMmAaaa.Substring(6, 4)
        hr = hora.Substring(0, 2)
        mins = hora.Substring(3, 2)
        segs = hora.Substring(6, 2)
        Return aaaa + "_" + mm + "_" + dd + "_" + hr + "_" + mins + "_" + segs
    End Function
    Public Function ComponeFechaDdMmAaaa(ByVal fechaAaaaMmDd As String) As String
        Dim aaaa, mm, dd As String
        If fechaAaaaMmDd Is Nothing Then
            Return ""
        End If
        If fechaAaaaMmDd.Trim.Equals("") Then
            Return ""
        End If
        'MsgBox("Argumento  fecha (" + fechaAaaaMmDd + ")")
        dd = fechaAaaaMmDd.Substring(8, 2)
        mm = fechaAaaaMmDd.Substring(5, 2)
        aaaa = fechaAaaaMmDd.Substring(0, 4)
        Return dd + "/" + mm + "/" + aaaa
    End Function
    Public Function obtieneDescripcion(ByVal tabla As String, ByVal numCampo As Integer, ByVal arrLlaves As String()) As String
        'La variable Llave tiene el identificador del registro
        Dim cnn As SQLiteConnection = ConectarBD()
        'estructura de datos
        'Crear un Comando para la conexin recien creada
        '
        Dim nCampos, nKeys As Integer
        nCampos = Util.numeroCampos(tabla, nCampos, nKeys)
        Dim nombres(nCampos), valores(nCampos) As String
        Dim Keys(nKeys) As Integer
        cargarNombresYNumsLlave(tabla, nombres, Keys)
        '
        '
        Dim campos As String = "*"
        Dim i As Integer
        Dim condicion As String = " WHERE " + nombres(Keys(1)) + " = '" & arrLlaves(Keys(1)) & "'"
        If Keys.Length - 2 > 0 Then
            For i = 2 To Keys.Length - 1
                condicion = condicion + " AND " + nombres(Keys(i)) + " = '" & arrLlaves(Keys(i)) & "'  "
            Next i
        End If
        Dim reader As DbDataReader = Util.EjecutarSelect(cnn, tabla, campos, condicion)
        If reader Is Nothing Then
            'MsgBox("El registro con llave (" + condicion + ") no existe")
            Return ""
        End If
        If Not reader.HasRows Then
            'MsgBox("El registro con llave (" + condicion + ") no existe")
            Return ""
        End If
        Dim valorRegreso = reader.GetValue(numCampo - 1)
        cnn.Close()
        Return valorRegreso
    End Function
    Public Function requiereRespaldo() As Boolean
        Dim Hoy = Date.Today.ToShortDateString
        Dim archivoFecha As String = "Fecha_Respaldo"
        Dim s As String
        Try
            Dim archivo_FechaEntrada As New System.IO.StreamReader(archivoFecha)
            s = archivo_FechaEntrada.ReadLine()
            archivo_FechaEntrada.Close()
        Catch ex As Exception
            s = ""
        End Try
        If s.Equals(Hoy) Then
            Return False
        Else
            Try
                Dim archivo_FechaSalida As New System.IO.StreamWriter(archivoFecha, False)
                archivo_FechaSalida.WriteLine(Hoy)
                archivo_FechaSalida.Close()
            Catch ex As Exception
                MsgBox("No se pudo generar el archivo de fecha")
                Return True
            End Try
        End If
        Return True
    End Function
    Public Sub RespaldaDataBase(ByVal pregunta As Boolean)
        Dim r As String
        If pregunta Then
            r = MessageBox.Show("Desea respaldar la base de datos? ", "Sistema de respaldos", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2, MessageBoxOptions.RightAlign, False).ToString
            If r <> "Yes" Then
                Return
            End If
        End If
        Dim Hoy = Date.Today.ToShortDateString
        Dim horaActual = Format(Now, "Long Time")
        Try
            My.Computer.FileSystem.CreateDirectory("RespaldosBD")
        Catch ex As Exception
        End Try
        Try
            My.Computer.FileSystem.CopyFile(dataBase, Application.StartupPath() + "/" + "RespaldosBD" + "/" + "RespaldoBD_del_" + Util.ComponeFechaHora(Hoy, horaActual) + ".db")
        Catch ex As Exception
            MsgBox("No se pudo generar el respaldo para (" + dataBase + ") " + vbCrLf + " se obtuvo el mensasje " + ex.Message)
            Return
        End Try
        'dataBase = OpenFileDialog1.CurrentDirectory + "/" + OpenFileDialog1.FileName
        MsgBox("Se ha respaldado la base de Datos (" + dataBase + ")")
        Return
    End Sub
    Public Sub PreparaBdParaEnviar()
        Shell("comprimeBd.bat ", AppWinStyle.MinimizedFocus)
    End Sub
    Public Sub InstalaBdRecibida()
        Shell("descomprimeBd.bat ", AppWinStyle.MinimizedFocus)
    End Sub
    Public Sub GeneraBd()
        Shell("compimeBd.bat ", AppWinStyle.MinimizedFocus)
    End Sub
    Public Sub CambiaDataBase()
        '1.-Revisar la variable con la Bd 
        Dim OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog()
        OpenFileDialog1.Filter = "Bases de datos |*.*db"
        OpenFileDialog1.InitialDirectory = Application.StartupPath() + "\"
        OpenFileDialog1.Title = "Seleccione una version de la Base de Datos"
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel Then
            MsgBox("Operacion cancelada se mantiene la Base de datos (" + dataBase + ")")
            Return
        End If
        'dataBase = OpenFileDialog1.CurrentDirectory + "/" + OpenFileDialog1.FileName
        dataBase = OpenFileDialog1.FileName
        MsgBox("Cambio de Base de datos a: (" + dataBase + ")")
    End Sub
    
    
    Private Sub inicializaArchivoSalida(ByVal archSalida As String)
        Dim smwArchivoSalida As StreamWriter = Nothing
        Try
            smwArchivoSalida = New StreamWriter(archSalida, False)
        Catch ex As Exception
            MsgBox("inicializaArchivoSalida: Archivo de entrada  con error " + archSalida + vbCrLf + ex.Message)
            Return
        End Try
        smwArchivoSalida.Close()
        Return
    End Sub
    Private Function abreArchivoSalida(ByVal archSalida As String) As StreamWriter
        Dim smwArchivoSalida As StreamWriter = Nothing
        Try
            smwArchivoSalida = New StreamWriter(archSalida, True)
        Catch ex As Exception
            MsgBox("abreArchivoSalida: Archivo de salida con error " + archSalida + vbCrLf + ex.Message)
            Return smwArchivoSalida
        End Try
        Return smwArchivoSalida
    End Function
    Private Function abreArchivoEntrada(ByVal archEntrada As String) As StreamReader
        Dim smrArchivoEntrada As StreamReader = Nothing
        Try
            smrArchivoEntrada = New StreamReader(archEntrada)
        Catch ex As Exception
            MsgBox("abreArchivoEntrada: Archivo de Entrada con error " + archEntrada + vbCrLf + ex.Message)
            Return smrArchivoEntrada
        End Try
        Return smrArchivoEntrada
    End Function
    
    Public Sub cargarDatosDeLaTabla(ByVal tabla As String, _
                                          ByVal ruta As String, _
                                          ByRef nombresArgs() As String, _
                                          ByVal numArgsLlave() As Integer, _
                                          ByRef tiposCampos() As String, _
                                          ByRef tiposCaptura() As String, _
                                          ByRef tablasExistencia() As String _
                                         )
        Dim entrada As String = ruta + "Tablas_" + dataBase + ".txt"
        Dim nCampos, nLlaves As Integer
        'Variable temporal para leer 
        Dim regLeido As String
        Dim archEntrada As StreamReader = abreArchivoEntrada(entrada)
        regLeido = archEntrada.ReadLine()
        nCampos = 0
        nLlaves = 0
        While Not archEntrada.EndOfStream
            If tabla.ToUpper.Equals(regLeido.Trim().ToUpper) Then
                Try
                    regLeido = archEntrada.ReadLine()
                    nCampos = Integer.Parse(regLeido.Trim())
                Catch ex As Exception
                    MsgBox("cargarDatosDeLaTabla: Datos Invalidos en la descripcion de la tabla para el numero de campos(" & _
                    tabla & ") archivo de entrada (" & entrada & ")" _
                    & vbCrLf & "dato leido (" & regLeido.Trim() & ") mensaje: " & ex.Message)
                    archEntrada.Close()
                    Return
                End Try
                Try
                    regLeido = archEntrada.ReadLine()
                    nLlaves = Integer.Parse(regLeido.Trim())
                Catch ex As Exception
                    MsgBox("cargarDatosDeLaTabla: Datos Invalidos en la descripcion de la tabla para el numero de llaves(" & _
                    tabla & ") archivo de entrada (" & entrada & ")" _
                    & vbCrLf & "dato leido (" & regLeido.Trim() & ") mensaje: " & ex.Message)
                    archEntrada.Close()
                    Return
                End Try
                Exit While
            End If
            regLeido = archEntrada.ReadLine()
        End While
        If nCampos <= 0 Then
            archEntrada.Close()
            MsgBox("cargarDatosDeLaTabla: No existe esta tabla en el archivo de tablas ")
            Return
        End If
        archEntrada.Close()
        entrada = ruta + "Campos_" + tabla + ".txt"
        Dim smrArchivoEntrada As StreamReader = Nothing
        Try
            smrArchivoEntrada = New StreamReader(entrada)
        Catch ex As Exception
            MsgBox("cargarDatosDeLaTabla:Archivo (" & entrada & ") de campos para la tabla (" & tabla & ") no puede abrirse " + entrada + vbCrLf + ex.Message)
            Return
        End Try
        archEntrada = smrArchivoEntrada
        Dim i As Integer
        For i = 1 To nCampos
            regLeido = archEntrada.ReadLine()
            nombresArgs(i) = regLeido.Trim()
            regLeido = archEntrada.ReadLine()
            tiposCampos(i) = regLeido.Trim()
            regLeido = archEntrada.ReadLine()
            tiposCaptura(i) = regLeido.Trim()
            regLeido = archEntrada.ReadLine()
            tablasExistencia(i) = regLeido.Trim()
        Next i
        archEntrada.Close()
        entrada = ruta + "Llaves_" + tabla + ".txt"
        Try
            smrArchivoEntrada = New StreamReader(entrada)
        Catch ex As Exception
            MsgBox("cargarDatosDeLaTabla:Archivo (" & entrada & ") de Llaves para la tabla (" & tabla & ") no puede abrirse " + entrada + vbCrLf + ex.Message)
            Return
        End Try
        archEntrada = smrArchivoEntrada
        For i = 1 To nLlaves
            regLeido = archEntrada.ReadLine()
            Try
                numArgsLlave(i) = Integer.Parse(regLeido.Trim())
            Catch ex As Exception
                numArgsLlave(i) = 0
            End Try
        Next i
        archEntrada.Close()
    End Sub
End Module


